/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  lpixport.h

\***************************************************************************/

#if !defined(LPIXPORT_H)
#define LPIXPORT_H
#define GlobalVersionNumber  7
/* ****************  INCLUDE ALL THE LOTUS SUPPLIED FILES  *************** */
#include "ltsdefs.h"
#include "lpisys.h"
/*  the following definition must follow lpisys and precede lpiprim */
#define LPI_ENVIRONMENT  LPI_123R3PC
#include "lpiprim.h"
#include "lpimemm.t"
#include "lpimemm.h"
#include "lpixport.t"
#include "lpickstk.h" /* also includes lpierror.h */
#include "lpienum.h"
#include "lpimisc.h"
/* ****************  DEFINE "NOGLOBALDATA" HERE IF NEEDED **************** */
/* #define NOGLOBALDATA */
/* *******************  OTHER #DEFINES HERE IF NEEDED ******************** */
#define VMR_0 0
#define VMR_1 1
#define VMR_2 2
#define VMR_3 3
/* ****************************  GLOBAL TYPEDEFS ************************* */
typedef lptr(struct LpiCellType_)       LpiCellType;
typedef lptr(struct LpiRangeType_)      LpiRangeType;
typedef lptr(struct LpiSheetType_)      LpiSheetType;
typedef lptr(struct LpiWorkfileType_)   LpiWorkfileType;
typedef lptr(struct LpiWorkspaceType_)  LpiWorkspaceType;
typedef lptr(struct LpiFileType_)       LpiFileType;
typedef lptr(struct LpiDisplayType_)    LpiDisplayType;
typedef lptr(struct LpiWindowType_)     LpiWindowType;
typedef lptr(struct LpiPromptType_)     LpiPromptType;
typedef lptr(struct LpiMenuType_)       LpiMenuType;
typedef lptr(struct LpiKeyboardType_)   LpiKeyboardType;
/* ************************ DECLARE MATH TABLE POINTER ******************* */
/* In order to use the lpi infix math, you must #define LPI_MAIN_MODULE in */
/* at least one C module which includes this file.  Usually this should be */
/* done in the same module that contains that bind/unbind routines.        */
#if defined(LPI_MAIN_MODULE)
lptr(MathTableType)   lpimathtable = LNULL;
lptr(MathTableType2)  lpimathtable2 = LNULL;
#else
extern lptr(MathTableType)   lpimathtable;
extern lptr(MathTableType2)   lpimathtable2;
#endif

/* ************************* DEFINE THE "USE" MACROS ********************* */
#if defined(USE_CELL)
#include "cell.plx"
#endif
#if defined(USE_RANGE)
#include "range.plx"
#endif
#if defined(USE_SHEET)
#include "sheet.plx"
#endif
#if defined(USE_WORKFILE)
#include "workfile.plx"
#endif
#if defined(USE_WKSPACE)
#include "wkspace.plx"
#endif
#if defined(USE_FILE)
#include "file.plx"
#endif
#if defined(USE_DISPLAY)
#include "window.plx"
#endif
#if defined(USE_WINDOW)
#include "window.plx"
#endif
#if defined(USE_INPUT)
#include "input.plx"
#endif
#if defined(USE_ATSTAT)
#include "atstat.plx"
#endif
#if defined(USE_ATFIN)
#include "atfin.plx"
#endif
#if defined(USE_ATDATE)
#include "atdate.plx"
#endif
#if defined(USE_ATDBASE)
#include "atdbase.plx"
#endif
#if defined(USE_ATSTR)
#include "atstr.plx"
#endif
#if defined(USE_ATSPCL)
#include "atspcl.plx"
#endif
#if defined(USE_ATLOGIC)
#include "atlogic.plx"
#endif
#if defined(USE_UTILITY)
#include "utility.plx"
#endif
#if defined(USE_MACRO)
#include "macro.plx"
#endif
#if defined(USE_REGISTER)
#include "register.plx"
#endif

#if defined(NOGLOBALDATA)       /* if global data is not allowed */
/* ****************  DEFINE SETUP MACROS FOR NOGLOBALDATA  *************** */
/* The following structure has its contents conditionally defined,
 * depending on which libraries the user has requested.  The USE_XXX macros
 * (defined above) include the PLX files with the needed definitions and
 * define the XXX_PLX symbols, which then determine the contents  of this
 * structure.
 */
typedef struct {
/* CELL */
#if defined(CELL_PLX)
    lptr(cl_exports)    cl_table;
    lptr(CONTEXT)      cl_global;
#endif
/* RANGE */
#if defined(RANGE_PLX)
    lptr(rng_exports)   rng_table;
    lptr(CONTEXT)      rng_global;
#endif
/* SHEET */
#if defined(SHEET_PLX)
    lptr(sh_exports)    sh_table;
    lptr(CONTEXT)      sh_global;
#endif
/* WORKFILE */
#if defined(WORKFILE_PLX)
    lptr(wf_exports)    wf_table;
    lptr(CONTEXT)      wf_global;
#endif
/* WORKSPACE */
#if defined(WKSPACE_PLX)
    lptr(ws_exports)    ws_table;
    lptr(CONTEXT)      ws_global;
#endif
/* FILE */
#if defined(FILE_PLX)
    lptr(file_exports)  file_table;
    lptr(CONTEXT)      file_global;
#endif
/* WINDOW/DISPLAY */
#if defined(WINDOW_PLX)
    lptr(win_exports)   win_table;
    lptr(CONTEXT)      win_global;
#endif
/* INPUT */
#if defined(INPUT_PLX)
    lptr(in_exports)    in_table;
    lptr(CONTEXT)      in_global;
#endif
/* ATSTAT */
#if defined(ATSTAT_PLX)
    lptr(atst_exports)  atst_table;
    lptr(CONTEXT)      atst_global;
#endif
/* ATFIN */
#if defined(ATFIN_PLX)
    lptr(atfin_exports) atfin_table;
    lptr(CONTEXT)      atfin_global;
#endif
/* ATDATE */
#if defined(ATDATE_PLX)
    lptr(atd_exports)   atd_table;
    lptr(CONTEXT)      atd_global;
#endif
/* ATDBASE */
#if defined(ATDBASE_PLX)
    lptr(atdb_exports)  atdb_table;
    lptr(CONTEXT)      atdb_global;
#endif
/* ATSTR */
#if defined(ATSTR_PLX)
    lptr(atstr_exports) atstr_table;
    lptr(CONTEXT)      atstr_global;
#endif
/* ATSPCL */
#if defined(ATSPCL_PLX)
    lptr(atspcl_exports) atspc_table;
    lptr(CONTEXT)      atspc_global;
#endif
/* ATLOGIC */
#if defined(ATLOGIC_PLX)
    lptr(atlog_exports) atlog_table;
    lptr(CONTEXT)      atlog_global;
#endif
/* UTILITY */
#if defined(UTILITY_PLX)
    lptr(util_exports)  util_table;
    lptr(CONTEXT)      util_global;
#endif
/* MACRO */
#if defined(MACRO_PLX)
    lptr(mac_exports)   mac_table;
    lptr(CONTEXT)      mac_global;
#endif
/* REGISTER */
#if defined(REGISTER_PLX)
    lptr(reg_exports)   reg_table;
    lptr(CONTEXT)      reg_global;
#endif
    LpiADTUTIL  utility_vector;
    lmhdl(void) instance_data;
    lptr(void)  user_data;
} lpiglobaldatatype;
#define LPI_CALL_DATA       ((lpiglobaldatatype *)LpiContext->LibData)
/* Allocate memory in LpiContext->LibData for the function table and,
 * as part of doing the setup, make the mathtables accessable to us all */
#define LPI_SETUP_LOAD     {LpiContext->LibData = (*LpiContext->Environment->alloc)((lulong)sizeof(lpiglobaldatatype)); \
                           if (LpiContext->LibData == LNULL) return(LPI_FAILURE); \
                           lpimathtable = LpiContext->Reserved2;lpimathtable2 = LpiContext->Reserved5;}
#define LPI_UNLOAD         (*LpiContext->Environment->dealloc)(LpiContext->LibData, (lulong)sizeof(lpiglobaldatatype))
#define LPI_LOAD_CELL      LpiSetupAltCall(ll3cell_name, &(LPI_CALL_DATA->cl_table),\
                                        &(LPI_CALL_DATA->cl_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_RANGE      LpiSetupAltCall(ll3range_name, &(LPI_CALL_DATA->rng_table),\
                                        &(LPI_CALL_DATA->rng_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_SHEET      LpiSetupAltCall(ll3sheet_name, &(LPI_CALL_DATA->sh_table),\
                                        &(LPI_CALL_DATA->sh_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_WORKFILE      LpiSetupAltCall(ll3wfile_name, &(LPI_CALL_DATA->wf_table),\
                                        &(LPI_CALL_DATA->wf_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_WKSPACE      LpiSetupAltCall(ll3wkspace_name, &(LPI_CALL_DATA->ws_table),\
                                        &(LPI_CALL_DATA->ws_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_FILE      LpiSetupAltCall(ll3file_name, &(LPI_CALL_DATA->file_table),\
                                        &(LPI_CALL_DATA->file_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_WINDOW      LpiSetupAltCall(ll3window_name, &(LPI_CALL_DATA->win_table),\
                                        &(LPI_CALL_DATA->win_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_INPUT      LpiSetupAltCall(ll3input_name, &(LPI_CALL_DATA->in_table),\
                                        &(LPI_CALL_DATA->in_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATSTAT      LpiSetupAltCall(ll3atstat_name, &(LPI_CALL_DATA->atst_table),\
                                        &(LPI_CALL_DATA->atst_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATFIN      LpiSetupAltCall(ll3atfin_name, &(LPI_CALL_DATA->atfin_table),\
                                        &(LPI_CALL_DATA->atfin_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATDATE      LpiSetupAltCall(ll3atdate_name, &(LPI_CALL_DATA->atd_table),\
                                        &(LPI_CALL_DATA->atd_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATDBASE      LpiSetupAltCall(ll3atdbase_name, &(LPI_CALL_DATA->atdb_table),\
                                        &(LPI_CALL_DATA->atdb_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATSTR      LpiSetupAltCall(ll3atstr_name, &(LPI_CALL_DATA->atstr_table),\
                                        &(LPI_CALL_DATA->atstr_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATSPCL      LpiSetupAltCall(ll3atspcl_name, &(LPI_CALL_DATA->atspc_table),\
                                        &(LPI_CALL_DATA->atspc_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATLOGIC      LpiSetupAltCall(ll3atlogic_name, &(LPI_CALL_DATA->atlog_table),\
                                        &(LPI_CALL_DATA->atlog_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_UTILITY      LpiSetupAltCall(ll3utility_name, &(LPI_CALL_DATA->util_table),\
                                        &(LPI_CALL_DATA->util_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_MACRO      LpiSetupAltCall(ll3macro_name, &(LPI_CALL_DATA->mac_table),\
                                        &(LPI_CALL_DATA->mac_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_REGISTER      LpiSetupAltCall(ll3register_name, &(LPI_CALL_DATA->reg_table),\
                                        &(LPI_CALL_DATA->reg_global),\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )

#else           /* for use with global data */
/* ****************  DEFINE SETUP MACROS FOR GLOBAL DATA OK *************** */
#if defined(CELL_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(cl_exports)    lts_cl_table = LNULL;
    lptr(CONTEXT)      lts_cl_global = LNULL;
#else
    extern lptr(cl_exports)    lts_cl_table;
    extern lptr(CONTEXT)      lts_cl_global;
#endif
#endif
/** RANGE */
#if defined(RANGE_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(rng_exports)   lts_rng_table = LNULL;
    lptr(CONTEXT)      lts_rng_global = LNULL;
#else
    extern lptr(rng_exports)   lts_rng_table;
    extern lptr(CONTEXT)      lts_rng_global;
#endif
#endif
/** SHEET */
#if defined(SHEET_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(sh_exports)    lts_sh_table = LNULL;
    lptr(CONTEXT)      lts_sh_global = LNULL;
#else
    extern lptr(sh_exports)    lts_sh_table;
    extern lptr(CONTEXT)      lts_sh_global;
#endif
#endif
/** WORKFILE */
#if defined(WORKFILE_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(wf_exports)    lts_wf_table = LNULL;
    lptr(CONTEXT)      lts_wf_global = LNULL;
#else
    extern lptr(wf_exports)    lts_wf_table;
    extern lptr(CONTEXT)      lts_wf_global;
#endif
#endif
/** WORKSPACE */
#if defined(WKSPACE_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(ws_exports)    lts_ws_table = LNULL;
    lptr(CONTEXT)      lts_ws_global = LNULL;
#else
    extern lptr(ws_exports)    lts_ws_table;
    extern lptr(CONTEXT)      lts_ws_global;
#endif
#endif
/** FILE */
#if defined(FILE_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(file_exports)  lts_file_table = LNULL;
    lptr(CONTEXT)      lts_file_global = LNULL;
#else
    extern lptr(file_exports)  lts_file_table;
    extern lptr(CONTEXT)      lts_file_global;
#endif
#endif
/** WINDOW/DISPLAY */
#if defined(WINDOW_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(win_exports)   lts_win_table = LNULL;
    lptr(CONTEXT)      lts_win_global = LNULL;
#else
    extern lptr(win_exports)   lts_win_table;
    extern lptr(CONTEXT)      lts_win_global;
#endif
#endif
/** INPUT */
#if defined(INPUT_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(in_exports)    lts_in_table = LNULL;
    lptr(CONTEXT)      lts_in_global = LNULL;
#else
    extern lptr(in_exports)    lts_in_table;
    extern lptr(CONTEXT)      lts_in_global;
#endif
#endif
/** ATSTAT */
#if defined(ATSTAT_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(atst_exports)  lts_atst_table = LNULL;
    lptr(CONTEXT)      lts_atst_global = LNULL;
#else
    extern lptr(atst_exports)  lts_atst_table;
    extern lptr(CONTEXT)      lts_atst_global;
#endif
#endif
/** ATFIN */
#if defined(ATFIN_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(atfin_exports) lts_atfin_table = LNULL;
    lptr(CONTEXT)      lts_atfin_global = LNULL;
#else
    extern lptr(atfin_exports) lts_atfin_table;
    extern lptr(CONTEXT)      lts_atfin_global;
#endif
#endif
/** ATDATE */
#if defined(ATDATE_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(atd_exports)   lts_atd_table = LNULL;
    lptr(CONTEXT)      lts_atd_global = LNULL;
#else
    extern lptr(atd_exports)   lts_atd_table;
    extern lptr(CONTEXT)      lts_atd_global;
#endif
#endif
/** ATDBASE */
#if defined(ATDBASE_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(atdb_exports)  lts_atdb_table = LNULL;
    lptr(CONTEXT)      lts_atdb_global = LNULL;
#else
    extern lptr(atdb_exports)  lts_atdb_table;
    extern lptr(CONTEXT)      lts_atdb_global;
#endif
#endif
/** ATSTR */
#if defined(ATSTR_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(atstr_exports) lts_atstr_table = LNULL;
    lptr(CONTEXT)      lts_atstr_global = LNULL;
#else
    extern lptr(atstr_exports) lts_atstr_table;
    extern lptr(CONTEXT)      lts_atstr_global;
#endif
#endif
/** ATSPCL */
#if defined(ATSPCL_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(atspcl_exports) lts_atspc_table = LNULL;
    lptr(CONTEXT)      lts_atspc_global = LNULL;
#else
    extern lptr(atspcl_exports) lts_atspc_table;
    extern lptr(CONTEXT)      lts_atspc_global ;
#endif
#endif
/** ATLOGIC */
#if defined(ATLOGIC_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(atlog_exports) lts_atlog_table = LNULL;
    lptr(CONTEXT)      lts_atlog_global = LNULL;
#else
    extern lptr(atlog_exports) lts_atlog_table;
    extern lptr(CONTEXT)      lts_atlog_global;
#endif
#endif
/** UTILITY */
#if defined(UTILITY_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(util_exports)  lts_ut_table = LNULL;
    lptr(CONTEXT)      lts_ut_global = LNULL;
#else
    extern lptr(util_exports)  lts_ut_table;
    extern lptr(CONTEXT)      lts_ut_global;
#endif
#endif
/** MACRO */
#if defined(MACRO_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(mac_exports)   lts_mac_table = LNULL;
    lptr(CONTEXT)      lts_mac_global = LNULL;
#else
    extern lptr(mac_exports)   lts_mac_table;
    extern lptr(CONTEXT)      lts_mac_global;
#endif
#endif
/** REGISTER */
#if defined(REGISTER_PLX)
#if defined(LPI_MAIN_MODULE)
    lptr(reg_exports)   lts_reg_table = LNULL;
    lptr(CONTEXT)      lts_reg_global = LNULL;
#else
    extern lptr(reg_exports)   lts_reg_table;
    extern lptr(CONTEXT)      lts_reg_global;
#endif
#endif
/* as part of doing the setup, make the mathtable accessable to us all */
#define LPI_SETUP_LOAD      lpimathtable = LpiContext->Reserved2;\
                            lpimathtable2 = LpiContext->Reserved5;
#define LPI_UNLOAD          LpiContext;
#define LPI_LOAD_CELL      LpiSetupAltCall(ll3cell_name, &lts_cl_table,\
                                        &lts_cl_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_RANGE      LpiSetupAltCall(ll3range_name, &lts_rng_table,\
                                        &lts_rng_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_SHEET      LpiSetupAltCall(ll3sheet_name, &lts_sh_table,\
                                        &lts_sh_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_WORKFILE      LpiSetupAltCall(ll3wfile_name, &lts_wf_table,\
                                        &lts_wf_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_WKSPACE      LpiSetupAltCall(ll3wkspace_name, &lts_ws_table,\
                                        &lts_ws_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_FILE      LpiSetupAltCall(ll3file_name, &lts_file_table,\
                                        &lts_file_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_WINDOW      LpiSetupAltCall(ll3window_name, &lts_win_table,\
                                        &lts_win_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_INPUT      LpiSetupAltCall(ll3input_name, &lts_in_table,\
                                        &lts_in_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATSTAT      LpiSetupAltCall(ll3atstat_name, &lts_atst_table,\
                                        &lts_atst_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATFIN      LpiSetupAltCall(ll3atfin_name, &lts_atfin_table,\
                                        &lts_atfin_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATDATE      LpiSetupAltCall(ll3atdate_name, &lts_atd_table,\
                                        &lts_atd_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATDBASE      LpiSetupAltCall(ll3atdbase_name, &lts_atdb_table,\
                                        &lts_atdb_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATSTR      LpiSetupAltCall(ll3atstr_name, &lts_atstr_table,\
                                        &lts_atstr_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATSPCL      LpiSetupAltCall(ll3atspcl_name, &lts_atspc_table,\
                                        &lts_atspc_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_ATLOGIC      LpiSetupAltCall(ll3atlogic_name, &lts_atlog_table,\
                                        &lts_atlog_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_UTILITY      LpiSetupAltCall(ll3utility_name, &lts_ut_table,\
                                        &lts_ut_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_MACRO      LpiSetupAltCall(ll3macro_name, &lts_mac_table,\
                                        &lts_mac_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#define LPI_LOAD_REGISTER      LpiSetupAltCall(ll3register_name, &lts_reg_table,\
                                        &lts_reg_global,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL,\
                                        (lulong)LNULL )
#endif
/* ***************** END OF DEFINING ALL THE GLOBAL MACROS **************** */
#endif  /* !defined(LPIXPORT_H) */
