/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  range.plx

\***************************************************************************/

#if !defined(RANGE_PLX)
#define RANGE_PLX
#define ll3range_name   "RANGE"
/* C callable function typedefs */
#define RNG_CONSTRUCT_CURRENT_ARGS (lptr(CONTEXT)            LpiContext,    \
                                    lptr(LpiRangeType)       p_newRange,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_CONSTRUCT_STRING_ARGS  (lptr(CONTEXT)            LpiContext,    \
                                    lptr(LpiRangeType)       p_newRange,    \
                                    lmhdl(lmbcs)             theAddress,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_CONSTRUCT_COORDS_ARGS  (lptr(CONTEXT)            LpiContext,    \
                                    lptr(LpiRangeType)       p_newRange,    \
                                    lmhdl(lmbcs)             theWorkfile,   \
                                    lulong                   ulc_z,         \
                                    lulong                   ulc_x,         \
                                    lulong                   ulc_y,         \
                                    lulong                   lrc_z,         \
                                    lulong                   lrc_x,         \
                                    lulong                   lrc_y,         \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_INPUT_ARGS             (lptr(CONTEXT)            LpiContext,    \
                                    lptr(LpiRangeType)       p_newRange,    \
                                    lmhdl(lmbcs)             thePrompt,     \
                                    lbool                    theAnchor,     \
                                    LpiRangeType             theDefault,    \
                                    lptr(lmhdl(lmbcs))       theHelp,       \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_DESTROY_ARGS           (lptr(CONTEXT)            LpiContext,    \
                                    lptr(LpiRangeType)       p_theRange)
#define RNG_STRING_ARGS            (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lmbcs)              p_dispBuf)
#define RNG_GET_ISVALID_ARGS       (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lbool)              p_theResult)
#define RNG_GET_DATATYPE_ARGS      (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lulong                   z,             \
                                    lulong                   x,             \
                                    lulong                   y,             \
                                    lptr(lushort)            p_theType,     \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_GET_CORNER_ARGS        (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lbool                    wantFirstCell, \
                                    lptr(lmbcs)              p_w,           \
                                    lptr(lushort)            p_z,           \
                                    lptr(lushort)            p_x,           \
                                    lptr(lushort)            p_y)
#define RNG_GET_WFILE_ARGS         (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lmbcs)              p_w)
#define RNG_GET_FIRST_SHEET_ARGS   (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_z)
#define RNG_GET_FIRST_COLUMN_ARGS  (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_x)
#define RNG_GET_FIRST_ROW_ARGS     (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_y)
#define RNG_GET_LAST_SHEET_ARGS    (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_z)
#define RNG_GET_LAST_COLUMN_ARGS   (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_x)
#define RNG_GET_LAST_ROW_ARGS      (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_y)
#define RNG_GET_NUM_SHEETS_ARGS    (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_sheetCount)
#define RNG_GET_NUM_COLUMNS_ARGS   (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_colCount)
#define RNG_GET_NUM_ROWS_ARGS      (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_rowCount)
#define RNG_SELECT_FLOAT_ARGS      (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  indexBase,     \
                                    lulong                   z,             \
                                    lulong                   x,             \
                                    lulong                   y,             \
                                    lptr(lfloat10)           p_theValue,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_SELECT_STRING_ARGS     (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  indexBase,     \
                                    lulong                   z,             \
                                    lulong                   x,             \
                                    lulong                   y,             \
                                    lptr(lmbcs)              p_theValue,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_REPLACE_FLOAT_ARGS     (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  indexBase,     \
                                    lulong                   z,             \
                                    lulong                   x,             \
                                    lulong                   y,             \
                                    lfloat10                 theValue)
#define RNG_REPLACE_STRING_ARGS    (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  indexBase,     \
                                    lulong                   z,             \
                                    lulong                   x,             \
                                    lulong                   y,             \
                                    lmhdl(lmbcs)             theValue)
#define RNG_SET_FORMAT_ARGS        (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  theFormat,     \
                                    lulong                   thePlaces,     \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_SET_LABEL_PREFIX_ARGS  (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  thePrefix,     \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_SET_PROTECTION_ARGS    (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lbool                    theSetting,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_SET_PARENTHESES_ARGS   (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lbool                    theSetting,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_SET_COLOR_NEG_ARGS     (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lbool                    theSetting,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_SET_HIGHLIGHT_ARGS     (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lbool                    theSetting,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_SET_HIDDEN_ARGS        (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lbool                    theSetting,    \
                                    lushort                  whichWindow)
#define RNG_SET_WIDTH_ARGS         (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lulong                   theWidth,      \
                                    lushort                  whichWindow)
#define RNG_RESET_WIDTH_ARGS       (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  whichWindow)
#define RNG_CREATE_NAME_ARGS       (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lmhdl(lmbcs)             theName,       \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_DELETE_NAME_ARGS       (lptr(CONTEXT)            LpiContext,    \
                                    lmhdl(lmbcs)             theName,       \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_RESET_NAMES_ARGS       (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_UNDEFINE_NAME_ARGS     (lptr(CONTEXT)            LpiContext,    \
                                    lmhdl(lmbcs)              theName,       \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_GET_NAME_COUNT_ARGS    (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_theCount)
#define RNG_GET_NAME_ARRAY_ARGS    (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lulong                   theArraySize,  \
                                    lptr(lmhdl(lmhdl(lmbcs))) p_theNames,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_GET_NOTE_ARGS          (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lmbcs)              p_theNote)
#define RNG_SET_NOTE_ARGS          (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lmhdl(lmbcs)             theNote)
#define RNG_JUSTIFY_ARGS           (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  whichWindow,   \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_COPY_ARGS              (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theFromRange,  \
                                    LpiRangeType             theToRange,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_COPY_VALUES_ARGS       (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theFromRange,  \
                                    LpiRangeType             theToRange,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_MOVE_ARGS              (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theFromRange,  \
                                    LpiRangeType             theToRange,    \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_TRANSPOSE_ARGS         (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theFromRange,  \
                                    LpiRangeType             theToRange,    \
                                    lushort                  theMethod,     \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_ERASE_ARGS             (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lptr(lushort)            p_theErrorCode)
#define RNG_CALC_ARGS              (lptr(CONTEXT)            LpiContext,    \
                                    LpiRangeType             theRange,      \
                                    lushort                  theOrder,      \
                                    lptr(lushort)            p_theErrorCode)
/* C callable function pointer table */
typedef struct {
    lexpptr (lsshort, lpi_rng_construct_current, RNG_CONSTRUCT_CURRENT_ARGS);
    lexpptr (lsshort, lpi_rng_construct_string,  RNG_CONSTRUCT_STRING_ARGS);
    lexpptr (lsshort, lpi_rng_construct_coords,  RNG_CONSTRUCT_COORDS_ARGS);
    lexpptr (lsshort, lpi_rng_input,             RNG_INPUT_ARGS);
    lexpptr (lsshort, lpi_rng_destroy,           RNG_DESTROY_ARGS);
    lexpptr (lsshort, lpi_rng_string,            RNG_STRING_ARGS);
    lexpptr (lsshort, lpi_rng_get_isvalid,       RNG_GET_ISVALID_ARGS);
    lexpptr (lsshort, lpi_rng_get_datatype,      RNG_GET_DATATYPE_ARGS);
    lexpptr (lsshort, lpi_rng_get_corner,        RNG_GET_CORNER_ARGS);
    lexpptr (lsshort, lpi_rng_get_wfile,         RNG_GET_WFILE_ARGS);
    lexpptr (lsshort, lpi_rng_get_first_sheet,   RNG_GET_FIRST_SHEET_ARGS);
    lexpptr (lsshort, lpi_rng_get_first_column,  RNG_GET_FIRST_COLUMN_ARGS);
    lexpptr (lsshort, lpi_rng_get_first_row,     RNG_GET_FIRST_ROW_ARGS);
    lexpptr (lsshort, lpi_rng_get_last_sheet,    RNG_GET_LAST_SHEET_ARGS);
    lexpptr (lsshort, lpi_rng_get_last_column,   RNG_GET_LAST_COLUMN_ARGS);
    lexpptr (lsshort, lpi_rng_get_last_row,      RNG_GET_LAST_ROW_ARGS);
    lexpptr (lsshort, lpi_rng_get_num_sheets,    RNG_GET_NUM_SHEETS_ARGS);
    lexpptr (lsshort, lpi_rng_get_num_columns,   RNG_GET_NUM_COLUMNS_ARGS);
    lexpptr (lsshort, lpi_rng_get_num_rows,      RNG_GET_NUM_ROWS_ARGS);
    lexpptr (lsshort, lpi_rng_select_float,      RNG_SELECT_FLOAT_ARGS);
    lexpptr (lsshort, lpi_rng_select_string,     RNG_SELECT_STRING_ARGS);
    lexpptr (lsshort, lpi_rng_replace_float,     RNG_REPLACE_FLOAT_ARGS);
    lexpptr (lsshort, lpi_rng_replace_string,    RNG_REPLACE_STRING_ARGS);
    lexpptr (lsshort, lpi_rng_set_format,        RNG_SET_FORMAT_ARGS);
    lexpptr (lsshort, lpi_rng_set_label_prefix,  RNG_SET_LABEL_PREFIX_ARGS);
    lexpptr (lsshort, lpi_rng_set_protection,    RNG_SET_PROTECTION_ARGS);
    lexpptr (lsshort, lpi_rng_set_parentheses,   RNG_SET_PARENTHESES_ARGS);
    lexpptr (lsshort, lpi_rng_set_color_neg,     RNG_SET_COLOR_NEG_ARGS);
    lexpptr (lsshort, lpi_rng_set_highlight,     RNG_SET_HIGHLIGHT_ARGS);
    lexpptr (lsshort, lpi_rng_set_hidden,        RNG_SET_HIDDEN_ARGS);
    lexpptr (lsshort, lpi_rng_set_width,         RNG_SET_WIDTH_ARGS);
    lexpptr (lsshort, lpi_rng_reset_width,       RNG_RESET_WIDTH_ARGS);
    lexpptr (lsshort, lpi_rng_create_name,       RNG_CREATE_NAME_ARGS);
    lexpptr (lsshort, lpi_rng_delete_name,       RNG_DELETE_NAME_ARGS);
    lexpptr (lsshort, lpi_rng_reset_names,       RNG_RESET_NAMES_ARGS);
    lexpptr (lsshort, lpi_rng_undefine_name,     RNG_UNDEFINE_NAME_ARGS);
    lexpptr (lsshort, lpi_rng_get_name_count,    RNG_GET_NAME_COUNT_ARGS);
    lexpptr (lsshort, lpi_rng_get_name_array,    RNG_GET_NAME_ARRAY_ARGS);
    lexpptr (lsshort, lpi_rng_get_note,          RNG_GET_NOTE_ARGS);
    lexpptr (lsshort, lpi_rng_set_note,          RNG_SET_NOTE_ARGS);
    lexpptr (lsshort, lpi_rng_justify,           RNG_JUSTIFY_ARGS);
    lexpptr (lsshort, lpi_rng_copy,              RNG_COPY_ARGS);
    lexpptr (lsshort, lpi_rng_copy_values,       RNG_COPY_VALUES_ARGS);
    lexpptr (lsshort, lpi_rng_move,              RNG_MOVE_ARGS);
    lexpptr (lsshort, lpi_rng_transpose,         RNG_TRANSPOSE_ARGS);
    lexpptr (lsshort, lpi_rng_erase,             RNG_ERASE_ARGS);
    lexpptr (lsshort, lpi_rng_calc,              RNG_CALC_ARGS);
} rng_exports;
/*-------------------------------------------------------------------------*\
                C Callable Interface Function Prototypes
\*-------------------------------------------------------------------------*/
lexppro (lsshort, lpi_rng_construct_current, RNG_CONSTRUCT_CURRENT_ARGS);
lexppro (lsshort, lpi_rng_construct_string,  RNG_CONSTRUCT_STRING_ARGS);
lexppro (lsshort, lpi_rng_construct_coords,  RNG_CONSTRUCT_COORDS_ARGS);
lexppro (lsshort, lpi_rng_input,             RNG_INPUT_ARGS);
lexppro (lsshort, lpi_rng_destroy,           RNG_DESTROY_ARGS);
lexppro (lsshort, lpi_rng_string,            RNG_STRING_ARGS);
lexppro (lsshort, lpi_rng_get_isvalid,       RNG_GET_ISVALID_ARGS);
lexppro (lsshort, lpi_rng_get_datatype,      RNG_GET_DATATYPE_ARGS);
lexppro (lsshort, lpi_rng_get_corner,        RNG_GET_CORNER_ARGS);
lexppro (lsshort, lpi_rng_get_wfile,         RNG_GET_WFILE_ARGS);
lexppro (lsshort, lpi_rng_get_first_sheet,   RNG_GET_FIRST_SHEET_ARGS);
lexppro (lsshort, lpi_rng_get_first_column,  RNG_GET_FIRST_COLUMN_ARGS);
lexppro (lsshort, lpi_rng_get_first_row,     RNG_GET_FIRST_ROW_ARGS);
lexppro (lsshort, lpi_rng_get_last_sheet,    RNG_GET_LAST_SHEET_ARGS);
lexppro (lsshort, lpi_rng_get_last_column,   RNG_GET_LAST_COLUMN_ARGS);
lexppro (lsshort, lpi_rng_get_last_row,      RNG_GET_LAST_ROW_ARGS);
lexppro (lsshort, lpi_rng_get_num_sheets,    RNG_GET_NUM_SHEETS_ARGS);
lexppro (lsshort, lpi_rng_get_num_columns,   RNG_GET_NUM_COLUMNS_ARGS);
lexppro (lsshort, lpi_rng_get_num_rows,      RNG_GET_NUM_ROWS_ARGS);
lexppro (lsshort, lpi_rng_select_float,      RNG_SELECT_FLOAT_ARGS);
lexppro (lsshort, lpi_rng_select_string,     RNG_SELECT_STRING_ARGS);
lexppro (lsshort, lpi_rng_replace_float,     RNG_REPLACE_FLOAT_ARGS);
lexppro (lsshort, lpi_rng_replace_string,    RNG_REPLACE_STRING_ARGS);
lexppro (lsshort, lpi_rng_set_format,        RNG_SET_FORMAT_ARGS);
lexppro (lsshort, lpi_rng_set_label_prefix,  RNG_SET_LABEL_PREFIX_ARGS);
lexppro (lsshort, lpi_rng_set_protection,    RNG_SET_PROTECTION_ARGS);
lexppro (lsshort, lpi_rng_set_parentheses,   RNG_SET_PARENTHESES_ARGS);
lexppro (lsshort, lpi_rng_set_color_neg,     RNG_SET_COLOR_NEG_ARGS);
lexppro (lsshort, lpi_rng_set_highlight,     RNG_SET_HIGHLIGHT_ARGS);
lexppro (lsshort, lpi_rng_set_hidden,        RNG_SET_HIDDEN_ARGS);
lexppro (lsshort, lpi_rng_set_width,         RNG_SET_WIDTH_ARGS);
lexppro (lsshort, lpi_rng_reset_width,       RNG_RESET_WIDTH_ARGS);
lexppro (lsshort, lpi_rng_create_name,       RNG_CREATE_NAME_ARGS);
lexppro (lsshort, lpi_rng_delete_name,       RNG_DELETE_NAME_ARGS);
lexppro (lsshort, lpi_rng_reset_names,       RNG_RESET_NAMES_ARGS);
lexppro (lsshort, lpi_rng_undefine_name,     RNG_UNDEFINE_NAME_ARGS);
lexppro (lsshort, lpi_rng_get_name_count,    RNG_GET_NAME_COUNT_ARGS);
lexppro (lsshort, lpi_rng_get_name_array,    RNG_GET_NAME_ARRAY_ARGS);
lexppro (lsshort, lpi_rng_get_note,          RNG_GET_NOTE_ARGS);
lexppro (lsshort, lpi_rng_set_note,          RNG_SET_NOTE_ARGS);
lexppro (lsshort, lpi_rng_justify,           RNG_JUSTIFY_ARGS);
lexppro (lsshort, lpi_rng_copy,              RNG_COPY_ARGS);
lexppro (lsshort, lpi_rng_copy_values,       RNG_COPY_VALUES_ARGS);
lexppro (lsshort, lpi_rng_move,              RNG_MOVE_ARGS);
lexppro (lsshort, lpi_rng_transpose,         RNG_TRANSPOSE_ARGS);
lexppro (lsshort, lpi_rng_erase,             RNG_ERASE_ARGS);
lexppro (lsshort, lpi_rng_calc,              RNG_CALC_ARGS);
/* C callable function macros -- use these to call Range functions! */
#if defined(LPIXPORT_H)
/* string buffer-length constants (PC only) */
#if (LPI_ENVIRONMENT == LPI_123R3PC)
#define LPI_RNG_NOTE_BUFLEN     513
#define LPI_RNG_CELL_BUFLEN     513
#define LPI_RNG_STRING_BUFLEN   181
#define LPI_RNG_FILEPATH_BUFLEN 157
#endif
/* 1-2-3 display window (primary/secondary) selectors */
#if !defined(WINDOW_1)
#define WINDOW_1        1
#endif
#if !defined(WINDOW_2)
#define WINDOW_2        2
#endif
/* cell coord bases for lpi_rng_select_xxx/lpi_rng_replace_xxx */
#define LPI_RNG_BASE_0  0
#define LPI_RNG_BASE_1  1
#define LPI_RNG_DEFAULT_PLACES   (lulong)2
#if defined(NOGLOBALDATA)
#define LPI_RNG_GLOBAL_REF  LPI_CALL_DATA->rng_global
#define LPI_RNG_TABLE_REF   LPI_CALL_DATA->rng_table
#else
/* global data IS supported -- perform calls through static struct */
#define LPI_RNG_GLOBAL_REF  lts_rng_global
#define LPI_RNG_TABLE_REF   lts_rng_table
#endif
#define LpiRngConstructCurrent(xADTdata, arg1)                    \
        (*LPI_RNG_TABLE_REF->lpi_rng_construct_current)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngConstructString(xADTdata, arg1, arg2)               \
        (*LPI_RNG_TABLE_REF->lpi_rng_construct_string)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngConstructCoords(xADTdata, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)\
        (*LPI_RNG_TABLE_REF->lpi_rng_construct_coords)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)
#define LpiRngInput(xADTdata, arg1, arg2, arg3)                              \
        (*LPI_RNG_TABLE_REF->lpi_rng_input)                           \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,LNULL,LNULL,arg3)
#define LpiRngInputHelp(xADTdata, arg1, arg2, arg3, arg4)                    \
        (*LPI_RNG_TABLE_REF->lpi_rng_input)                           \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,LNULL,arg3,arg4)
#define LpiRngInputDefault(xADTdata, arg1, arg2, arg3, arg4)                 \
        (*LPI_RNG_TABLE_REF->lpi_rng_input)                           \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,arg3,LNULL,arg4)
#define LpiRngInputDefaultHelp(xADTdata, arg1, arg2, arg3, arg4, arg5)       \
        (*LPI_RNG_TABLE_REF->lpi_rng_input)                           \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4,arg5)
#define LpiRngDestroy(xADTdata)                                   \
        (*LPI_RNG_TABLE_REF->lpi_rng_destroy)                            \
        (LPI_RNG_GLOBAL_REF,xADTdata)
#define LpiRngString(xADTdata, arg1)                              \
        (*LPI_RNG_TABLE_REF->lpi_rng_string)                          \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetIsValid(xADTdata, arg1)                          \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_isvalid)                     \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetDataType(xADTdata, arg1, arg2, arg3, arg4) \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_datatype)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,(lulong)1,arg1,arg2,arg3,arg4)
#define LpiRngGetDataTypeSheet(xADTdata, arg1, arg2, arg3, arg4, arg5)       \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_datatype)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,arg3,arg4,arg5)
#define LpiRngGetFirstCell(xADTdata, arg1, arg2, arg3, arg4)      \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_corner)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,LTRUE,arg1,arg2,arg3,arg4)
#define LpiRngGetLastCell(xADTdata, arg1, arg2, arg3, arg4)       \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_corner)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LFALSE,arg1,arg2,arg3,arg4)
#define LpiRngGetWorkFileName(xADTdata, arg1)                            \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_wfile)                       \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetFirstSheet(xADTdata, arg1)                       \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_first_sheet)                 \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetFirstColumn(xADTdata, arg1)                      \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_first_column)                \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetFirstRow(xADTdata, arg1)                         \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_first_row)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetLastSheet(xADTdata, arg1)                        \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_last_sheet)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetLastColumn(xADTdata, arg1)                       \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_last_column)                 \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetLastRow(xADTdata, arg1)                          \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_last_row)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetSheets(xADTdata, arg1)                        \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_num_sheets)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetColumns(xADTdata, arg1)                       \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_num_columns)                 \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngGetRows(xADTdata, arg1)                          \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_num_rows)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngSelectFloat(xADTdata, arg1, arg2, arg3, arg4) \
        (*LPI_RNG_TABLE_REF->lpi_rng_select_float)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,1L,arg1,arg2,arg3,arg4)
#define LpiRngSelectFloatSheet(xADTdata, arg1, arg2, arg3, arg4, arg5) \
        (*LPI_RNG_TABLE_REF->lpi_rng_select_float)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,arg1,arg2,arg3,arg4,arg5)
#define LpiRngSelectString(xADTdata, arg1, arg2, arg3, arg4)\
        (*LPI_RNG_TABLE_REF->lpi_rng_select_string)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,1L,arg1,arg2,arg3,arg4)
#define LpiRngSelectStringSheet(xADTdata, arg1, arg2, arg3, arg4, arg5)\
        (*LPI_RNG_TABLE_REF->lpi_rng_select_string)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,arg1,arg2,arg3,arg4,arg5)
#define LpiRngReplaceFloatSheet(xADTdata, arg1, arg2, arg3, arg4)      \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_float)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,arg1,arg2,arg3,arg4)
#define LpiRngReplaceFloat(xADTdata, arg1, arg2, arg3)      \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_float)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,1L,arg1,arg2,arg3)
#define LpiRngReplaceString(xADTdata, arg1, arg2, arg3)     \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_string)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,1L, arg1,arg2,arg3)
#define LpiRngReplaceStringSheet(xADTdata, arg1, arg2, arg3, arg4)     \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_string)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_1,arg1,arg2,arg3,arg4)
#define LpiRngIndexFloat(xADTdata, arg1, arg2, arg3, arg4)        \
        (*LPI_RNG_TABLE_REF->lpi_rng_select_float)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,0L,arg1,arg2,arg3,arg4)
#define LpiRngIndexFloatSheet(xADTdata, arg1, arg2, arg3, arg4, arg5)  \
        (*LPI_RNG_TABLE_REF->lpi_rng_select_float)                    \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,arg1,arg2,arg3,arg4,arg5)
#define LpiRngIndexString(xADTdata, arg1, arg2, arg3, arg4) \
        (*LPI_RNG_TABLE_REF->lpi_rng_select_string)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,0L,arg1,arg2,arg3,arg4)
#define LpiRngIndexStringSheet(xADTdata, arg1, arg2, arg3, arg4, arg5) \
        (*LPI_RNG_TABLE_REF->lpi_rng_select_string)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,arg1,arg2,arg3,arg4,arg5)
#define LpiRngPutFloat(xADTdata, arg1, arg2, arg3)                \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_float)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,0L,arg1,arg2,arg3)
#define LpiRngPutFloatSheet(xADTdata, arg1, arg2, arg3, arg4)     \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_float)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,arg1,arg2,arg3,arg4)
#define LpiRngPutString(xADTdata, arg1, arg2, arg3)               \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_string)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,0L,arg1,arg2,arg3)
#define LpiRngPutStringSheet(xADTdata, arg1, arg2, arg3, arg4)    \
        (*LPI_RNG_TABLE_REF->lpi_rng_replace_string)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,LPI_RNG_BASE_0,arg1,arg2,arg3,arg4)
#define LpiRngSetFormat(xADTdata, arg1, arg2)                     \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_format)                      \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,LPI_RNG_DEFAULT_PLACES,arg2)
#define LpiRngSetFormatPlaces(xADTdata, arg1, arg2, arg3)               \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_format)                      \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,arg3)
#define LpiRngSetLabelPrefix(xADTdata, arg1, arg2)                \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_label_prefix)                \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngSetProtection(xADTdata, arg1, arg2)                 \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_protection)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngSetParentheses(xADTdata, arg1, arg2)                \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_parentheses)                 \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngSetColorNegative(xADTdata, arg1, arg2)                   \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_color_neg)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngSetHighlight(xADTdata, arg1, arg2)                  \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_highlight)                   \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngSetHidden(xADTdata, arg1)                           \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_hidden)                      \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,WINDOW_1)
#define LpiRngSetHiddenWin(xADTdata, arg1, arg2)                  \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_hidden)                      \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngSetWidth(xADTdata, arg1)                            \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_width)                       \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,WINDOW_1)
#define LpiRngSetWidthWin(xADTdata, arg1, arg2)                   \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_width)                       \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngWidthReset(xADTdata)                                \
        (*LPI_RNG_TABLE_REF->lpi_rng_reset_width)                     \
        (LPI_RNG_GLOBAL_REF,xADTdata,WINDOW_1)
#define LpiRngWidthResetWin(xADTdata, arg1)                       \
        (*LPI_RNG_TABLE_REF->lpi_rng_reset_width)                     \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngNameCreate(xADTdata, arg1, arg2)                    \
        (*LPI_RNG_TABLE_REF->lpi_rng_create_name)                     \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngNameDelete(arg1, arg2)                              \
        (*LPI_RNG_TABLE_REF->lpi_rng_delete_name)                     \
        (LPI_RNG_GLOBAL_REF,arg1,arg2)
#define LpiRngNameReset(xADTdata, arg1)                          \
        (*LPI_RNG_TABLE_REF->lpi_rng_reset_names)                     \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngNameUndefine(arg1, arg2)                            \
        (*LPI_RNG_TABLE_REF->lpi_rng_undefine_name)                   \
        (LPI_RNG_GLOBAL_REF,arg1,arg2)
#define LpiRngNameCount(xADTdata, arg1)                        \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_name_count)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngNameArray(xADTdata, arg1, arg2, arg3)            \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_name_array)                  \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2,arg3)
#define LpiRngGetNote(xADTdata, arg1)                             \
        (*LPI_RNG_TABLE_REF->lpi_rng_get_note)                        \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngSetNote(xADTdata, arg1)                             \
        (*LPI_RNG_TABLE_REF->lpi_rng_set_note)                        \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngJustify(xADTdata, arg1)                             \
        (*LPI_RNG_TABLE_REF->lpi_rng_justify)                         \
        (LPI_RNG_GLOBAL_REF,xADTdata,WINDOW_1,arg1)
#define LpiRngJustifyWin(xADTdata, arg1, arg2)                    \
        (*LPI_RNG_TABLE_REF->lpi_rng_justify)                         \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#define LpiRngCopy(xADTdata1, xADTdata2, arg1)                    \
        (*LPI_RNG_TABLE_REF->lpi_rng_copy)                            \
        (LPI_RNG_GLOBAL_REF,xADTdata1,xADTdata2,arg1)
#define LpiRngCopyValues(xADTdata1, xADTdata2, arg1)              \
        (*LPI_RNG_TABLE_REF->lpi_rng_copy_values)                     \
        (LPI_RNG_GLOBAL_REF,xADTdata1,xADTdata2,arg1)
#define LpiRngMove(xADTdata1, xADTdata2, arg1)                    \
        (*LPI_RNG_TABLE_REF->lpi_rng_move)                            \
        (LPI_RNG_GLOBAL_REF,xADTdata1,xADTdata2,arg1)
#define LpiRngTranspose(xADTdata1, xADTdata2, arg1, arg2)         \
        (*LPI_RNG_TABLE_REF->lpi_rng_transpose)                       \
        (LPI_RNG_GLOBAL_REF,xADTdata1,xADTdata2,arg1,arg2)
#define LpiRngErase(xADTdata, arg1)                               \
        (*LPI_RNG_TABLE_REF->lpi_rng_erase)                           \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1)
#define LpiRngCalc(xADTdata, arg1, arg2)                          \
        (*LPI_RNG_TABLE_REF->lpi_rng_calc)                        \
        (LPI_RNG_GLOBAL_REF,xADTdata,arg1,arg2)
#endif  /* defined(LPIXPORT_H) */
#endif  /* !defined(RANGE_PLX) */
