/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  commport.plx

   1.  Lotus grants you a non-exclusive royalty-free right to use and modify
       the source code version and to reproduce and distribute the object
       code version of the Example Programs provided in the Toolkit, provided
       that you:

       a) distribute the Example Programs only in conjunction with and as a
          part of your software application product which is designed as an
          add-in to Lotus 1-2-3, and

       b) do not represent your product to be a product of Lotus Development
          Corporation.

   2.  The Example Programs are provided as is, without warranty of any kind,
       either express or implied, including, without limitation, the implied
       warranties of merchantability of fitness for a particular purpose.

\***************************************************************************/


#if !defined(COMMPORT_PLX)
#define COMMPORT_PLX

/* This name is used when the external users calls the runtime module
 * to get the pointer to the exported C callable functions for this
 * module.  Module names are stored in the runtime with the pointer to
 * the alternate exported functions.  This name must be identical to the
 * LPL module name in order for the lookup to work correctly.
 */
#define commport_name "COMMPORT"           /* name of primitive module */


/* Argument defines for C-callable functions.
 * These #defines are used by the lexppro, lexpptr, and lexpfnc macros to
 * define prototypes, exported function pointers, and function declarations
 * respectively.  This simplifies maintainance chores by having a central
 * spot in which the actual definition is kept.  This will not work correctly
 * in non-ANSI C implementations, however.
 */
#define LPI_CP_DEST_ARGS\
 (lptr(CONTEXT) LpiContext,\
 lptr(LpiCommportType) p_theCommport)

#define LPI_CP_CONST_ARGS\
 (lptr(CONTEXT) LpiContext,\
 lptr(LpiCommportType) p_theCommport)

#define LPI_CP_STRING_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType theCommport,\
 lptr(lmhdl(lmbcs)) p_theString)


#define LPI_CP_SET_BAUDRATE_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lslong theRate)

#define LPI_CP_GET_BAUDRATE_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lptr(lslong) theRate)

#define LPI_CP_SET_PORT_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lsshort thePort)

#define LPI_CP_GET_PORT_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lptr(lsshort) thePort)

#define LPI_CP_SET_DATABITS_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lsshort theBits)

#define LPI_CP_GET_DATABITS_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lptr(lsshort) theBits)

#define LPI_CP_SET_STOPBITS_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lsshort theBits)

#define LPI_CP_GET_STOPBITS_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lptr(lsshort) theBits)

#define LPI_CP_SET_PARITY_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lsshort theParity)

#define LPI_CP_GET_PARITY_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lptr(lsshort) theParity)

#define LPI_CP_OPEN_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport)

#define LPI_CP_CLOSE_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport)

#define LPI_CP_SELECT_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lptr(lmhdl(lmbcs)) theString)

#define LPI_CP_REPLACE_ARGS\
 (lptr(CONTEXT) LpiContext,\
 LpiCommportType p_theCommport,\
 lmhdl(lmbcs) theString)




/* Prototypes for C callable functions
 * These prototypes are created using the LTSDEFS lexppro macro.
 */

lexppro (lsshort, lpi_cp_destroy, LPI_CP_DEST_ARGS);
lexppro (lsshort, lpi_cp_construct, LPI_CP_CONST_ARGS);
lexppro (lsshort, lpi_cp_string, LPI_CP_STRING_ARGS);
lexppro (lsshort, lpi_cp_set_baudrate, LPI_CP_SET_BAUDRATE_ARGS);
lexppro (lsshort, lpi_cp_get_baudrate, LPI_CP_GET_BAUDRATE_ARGS);
lexppro (lsshort, lpi_cp_set_port, LPI_CP_SET_PORT_ARGS);
lexppro (lsshort, lpi_cp_get_port, LPI_CP_GET_PORT_ARGS);
lexppro (lsshort, lpi_cp_set_databits, LPI_CP_SET_DATABITS_ARGS);
lexppro (lsshort, lpi_cp_get_databits, LPI_CP_GET_DATABITS_ARGS);
lexppro (lsshort, lpi_cp_set_stopbits, LPI_CP_SET_STOPBITS_ARGS);
lexppro (lsshort, lpi_cp_get_stopbits, LPI_CP_GET_STOPBITS_ARGS);
lexppro (lsshort, lpi_cp_set_parity, LPI_CP_SET_PARITY_ARGS);
lexppro (lsshort, lpi_cp_get_parity, LPI_CP_GET_PARITY_ARGS);
lexppro (lsshort, lpi_cp_open, LPI_CP_OPEN_ARGS);
lexppro (lsshort, lpi_cp_close, LPI_CP_CLOSE_ARGS);
lexppro (lsshort, lpi_cp_select, LPI_CP_SELECT_ARGS);
lexppro (lsshort, lpi_cp_replace, LPI_CP_REPLACE_ARGS);



/* Pointers to C callable functions
 * This table is created using the LTSDEFS lexpptr macro.
 * The name of the table (cp_exports in this case) must correspond to the
 * name #defined as AltExportType in the main C file (the one with the
 * bind routine).  For users, the table name is the type used to declare
 * a pointer to your exported procedures.
 */
typedef struct {
    lexpptr (lsshort, lpi_cp_construct, LPI_CP_CONST_ARGS);
    lexpptr (lsshort, lpi_cp_destroy, LPI_CP_DEST_ARGS);
    lexpptr (lsshort, lpi_sh_string, LPI_CP_STRING_ARGS);
    lexpptr (lsshort, lpi_cp_set_baudrate, LPI_CP_SET_BAUDRATE_ARGS);
    lexpptr (lsshort, lpi_cp_get_baudrate, LPI_CP_GET_BAUDRATE_ARGS);
       lexpptr (lsshort, lpi_cp_set_port, LPI_CP_SET_PORT_ARGS);
       lexpptr (lsshort, lpi_cp_get_port, LPI_CP_GET_PORT_ARGS);
       lexpptr (lsshort, lpi_cp_set_databits, LPI_CP_SET_DATABITS_ARGS);
       lexpptr (lsshort, lpi_cp_get_databits, LPI_CP_GET_DATABITS_ARGS);
       lexpptr (lsshort, lpi_cp_set_stopbits, LPI_CP_SET_STOPBITS_ARGS);
       lexpptr (lsshort, lpi_cp_get_stopbits, LPI_CP_GET_STOPBITS_ARGS);
       lexpptr (lsshort, lpi_cp_set_parity, LPI_CP_SET_PARITY_ARGS);
       lexpptr (lsshort, lpi_cp_get_parity, LPI_CP_GET_PARITY_ARGS);
       lexpptr (lsshort, lpi_cp_open, LPI_CP_OPEN_ARGS);
       lexpptr (lsshort, lpi_cp_close, LPI_CP_CLOSE_ARGS);
       lexpptr (lsshort, lpi_cp_select, LPI_CP_SELECT_ARGS);
       lexpptr (lsshort, lpi_cp_replace, LPI_CP_REPLACE_ARGS);
} cp_exports;


#if defined(LPIXPORT_H)

#if defined(NOGLOBALDATA)

/* if NOGLOBALDATA is defined, then we must always store the function
 * pointer in the LibData area, not in global data.  This initializes
 * the macros to use the LibData area of LpiContext.
 */
#define LPI_CP_GLOBAL_REF  LPI_CALL_DATA->cp_global
#define LPI_CP_TABLE_REF   LPI_CALL_DATA->cp_table

#else

/* if NOGLOBALDATA is not defined then we can access the function table
 * using global variables rather than the LibData area of LpiContext.
 */
#define LPI_CP_GLOBAL_REF  lts_cp_global
#define LPI_CP_TABLE_REF   lts_cp_table

#endif

/* macros to call the functions pointed to by the table created above
 */

#define LpiCpConstruct(xdata)                       \
        (*LPI_CP_TABLE_REF->lpi_cp_construct)       \
        (LPI_CP_GLOBAL_REF, xdata)

#define LpiCpDestroy(xADTdata)                      \
        (*LPI_CP_TABLE_REF->lpi_cp_destroy)         \
        (LPI_CP_GLOBAL_REF, xADTdata )

#define LpiCpString(xADTdata, arg1)                 \
        (*LPI_CP_TABLE_REF->lpi_sh_string)          \
        (LPI_CP_GLOBAL_REF, xADTdata, arg1)

#define LpiCpSetBaudrate(xdata, arg1)               \
        (*LPI_CP_TABLE_REF->lpi_cp_set_baudrate)    \
        (LPI_CP_GLOBAL_REF, xdata, arg1)

#define LpiCpGetBaudrate(xADTdata, arg1)            \
        (*LPI_CP_TABLE_REF->lpi_cp_get_baudrate)    \
        (LPI_CP_GLOBAL_REF, xADTdata, arg1 )

#define LpiCpSetPort(xdata, arg1)                   \
        (*LPI_CP_TABLE_REF->lpi_cp_set_port)        \
        (LPI_CP_GLOBAL_REF, xdata, arg1)

#define LpiCpGetPort(xADTdata, arg1)                \
        (*LPI_CP_TABLE_REF->lpi_cp_get_port)        \
        (LPI_CP_GLOBAL_REF, xADTdata, arg1 )

#define LpiCpSetDatabits(xdata, arg1)               \
        (*LPI_CP_TABLE_REF->lpi_cp_set_databits)    \
        (LPI_CP_GLOBAL_REF, xdata, arg1)

#define LpiCpGetDatabits(xADTdata, arg1)            \
        (*LPI_CP_TABLE_REF->lpi_cp_get_databits)    \
        (LPI_CP_GLOBAL_REF, xADTdata, arg1 )

#define LpiCpSetStopbits(xdata, arg1)               \
        (*LPI_CP_TABLE_REF->lpi_cp_set_stopbits)    \
        (LPI_CP_GLOBAL_REF, xdata, arg1)

#define LpiCpGetStopbits(xADTdata, arg1)            \
        (*LPI_CP_TABLE_REF->lpi_cp_get_stopbits)    \
        (LPI_CP_GLOBAL_REF, xADTdata, arg1 )

#define LpiCpSetParity(xdata, arg1)                 \
        (*LPI_CP_TABLE_REF->lpi_cp_set_parity)      \
        (LPI_CP_GLOBAL_REF, xdata, arg1)

#define LpiCpGetParity(xADTdata, arg1)              \
        (*LPI_CP_TABLE_REF->lpi_cp_get_parity)      \
        (LPI_CP_GLOBAL_REF, xADTdata, arg1 )

#define LpiCpOpen(xdata)                            \
        (*LPI_CP_TABLE_REF->lpi_cp_open)            \
        (LPI_CP_GLOBAL_REF, xdata)

#define LpiCpClose(xADTdata)                        \
        (*LPI_CP_TABLE_REF->lpi_cp_close)           \
        (LPI_CP_GLOBAL_REF, xADTdata)

#define LpiCpSelect(xdata, arg1)                    \
        (*LPI_CP_TABLE_REF->lpi_cp_select)          \
        (LPI_CP_GLOBAL_REF, xdata, arg1)

#define LpiCpReplace(xADTdata, arg1)                \
        (*LPI_CP_TABLE_REF->lpi_cp_replace)         \
        (LPI_CP_GLOBAL_REF, xADTdata, arg1 )


#endif      /* all the exported macros */

#endif      /* the entire file */

