/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  template.c

   1.  Lotus grants you a non-exclusive royalty-free right to use and modify
       the source code version and to reproduce and distribute the object
       code version of the Example Programs provided in the Toolkit, provided
       that you:

       a) distribute the Example Programs only in conjunction with and as a
          part of your software application product which is designed as an
          add-in to Lotus 1-2-3, and

       b) do not represent your product to be a product of Lotus Development
          Corporation.

   2.  The Example Programs are provided as is, without warranty of any kind,
       either express or implied, including, without limitation, the implied
       warranties of merchantability of fitness for a particular purpose.

\***************************************************************************/

#define LPI_MAIN_MODULE

#include "template.plh"
#include "lpixport.h"

#if defined(DEBUGON)
#include "debug.h"
#endif

LpiBindProto (template_b);
LpiUnbindProto (template_u);
LpiProto (template_func);


LpiDecl(template_func)
{
   IgnoreParameters;

   /* This is where your primitive code goes.  This routine is callable
    * from LPL.
    */
    LpiSignal( LPI_SUCCESS );
}


LpiBind(template_b)
{
   /* The following 3 lines set up a table of functions which can be called
    * from LPL.
    */
   LpiSetBegin
      LpiSet(template_func)
   LpiSetEnd

   LpiSetCode(TEMPLATE_STAMP_0, TEMPLATE_STAMP_1, TEMPLATE_VERSION );

   /***********************************************************************
    *
    * The following code loads the function tables and context information
    * for modules that have been requested at the top of the file.  This
    * code need not be changed, loads will be automatic.
    *
    ***********************************************************************/

   LPI_SETUP_LOAD;   /* start loading pointers to used modules */

   #if defined (USE_CELL)
      if (LPI_LOAD_CELL != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_RANGE)
      if (LPI_LOAD_RANGE    != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_SHEET)
      if (LPI_LOAD_SHEET    != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_WORKFILE)
      if (LPI_LOAD_WORKFILE != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_WKSPACE)
      if (LPI_LOAD_WKSPACE  != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_WINDOW)
      if (LPI_LOAD_WINDOW   != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_INPUT)
      if (LPI_LOAD_INPUT    != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_FILE)
      if (LPI_LOAD_FILE     != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_MACRO)
      if (LPI_LOAD_MACRO    != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_UTILITY)
      if (LPI_LOAD_UTILITY  != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_REGISTER)
      if (LPI_LOAD_REGISTER != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_ATDATE)
      if (LPI_LOAD_ATDATE   != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_ATDBASE)
      if (LPI_LOAD_ATDBASE  != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_ATFIN)
      if (LPI_LOAD_ATFIN    != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_ATSPCL)
      if (LPI_LOAD_ATSPCL   != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_ATSTAT)
      if (LPI_LOAD_ATSTAT   != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

   #if defined (USE_ATSTR)
      if (LPI_LOAD_ATSTR    != LPI_SUCCESS) LpiSignal (LPI_FAILURE);
   #endif

#if defined(DEBUGON)
   debug();
#endif

   LpiSignal(LPI_SUCCESS);    /* everything is ok since we got here */
}


/************************************************************************
 *
 * This is the unbind routine.  It is called only when Alt-F10 Remove or
 * Alt-F10 Clear are invoked by the user.  The code in this routine should
 * work for most circumstances.
 *
 ************************************************************************/

LpiUnbind(template_u)
{
   LPI_UNLOAD;
   LpiSignal(LPI_SUCCESS);
}

